/* DSP LABORATORY 
 * University of Technology Graz, 2018
 * Josef Kulmer
 */

#ifndef FOURIERTRANSFORM_H
#define FOURIERTRANSFORM_H

#include <fftw3.h>
#include <vector>
#include <random>
#include <fstream>

class Fouriertransform{
private:
    float *inft; // DFT
    fftwf_complex *outft;
    fftwf_complex *inift; // inverse DFT
    float *outift;
    fftwf_plan p, pi;
    std::vector<float> windowfcn; // store hamming window
    const float PI = 3.141592654;
public:
    Fouriertransform();
    ~Fouriertransform();
    // do Power Spectral Density estimation
    void doDFT(const void *, const void *, const void *, unsigned long);
    void doIDFT(const void *, const void *, const void *, unsigned long);
    void doWindowfcn(const void *, unsigned long);
};

#endif /* FOURIERTRANSFORM_H */

