% Implementation of
% RJ McAulay and ML Malpass: Speech Enhancement Using a ...
%   Soft-Decision Noise Suppression Filter, IEEE Trans. ASSP, 1980
% Josef Kulmer, Nov 2018
% Graz, University of Technology

fs=16000;
Nbits=16;
Nchannels=2;
Nrecordtime=5;

Nf=256;
Ns=Nf/2;

red=audiorecorder(fs,Nbits,Nchannels);
red.StartFcn = 'disp(''Start speaking.'')';
red.StopFcn = 'disp(''End of recording.'')';

% record 5 seconds
record(red,5);

pause(Nrecordtime + 1)

y=getaudiodata(red);

% cut in frames
for i=1:(Nrecordtime*fs/Ns-Ns)
    xs(:,i)=y((1:Nf) + Ns*(i-1),1);
    xn(:,i)=y((1:Nf) + Ns*(i-1),2);
end

imagesc(20*log10(abs(fft(xn))))

Xs=fft(xs);

G=ones(size(Xs));

Xr=Xs.*G;

% synthesis
xola=zeros(length(y(:,1)),1);
for i=1:(Nrecordtime*fs/Ns-Ns)
    xola((i-1)*Ns + (1:Nf))=xola((i-1)*Ns + (1:Nf)) + ifft(Xr(:,i)).*hamming(Nf);
end

sound(xola(:,1),fs)
