/* DSP LABORATORY 
 * University of Technology Graz, 2018
 * Josef Kulmer
 * 
 */

#include "math.h"
#include <iostream>
#include "blockprocessing.h"
#include "WienerFilter.h"
#include "Fouriertransform.h"

WienerFilter::WienerFilter() { //constructor
// put here initialization
    specreal.resize(FRAMELENGTH/2+1);
    specimag.resize(FRAMELENGTH/2+1);
};

WienerFilter::~WienerFilter() { //deconstructor
};

void WienerFilter::doSpeechEnhancement(const void *inSpeech, const void *inNoise, const void *out, unsigned long framelength) {
    float *inputSpeech = (float*) inSpeech;
    float *inputNoise = (float*) inNoise;
    float *output = (float*) out;
    
    // put here your implementation
    
    // do DFT
    FT.doDFT(inputSpeech, &specreal[0], &specimag[0], framelength);
    
    // do inverse DFT
    FT.doIDFT(&specreal[0], &specimag[0], output, framelength);
}