/* DSP LABORATORY 
 * University of Technology Graz, 2018
 * Josef Kulmer
 */

#ifndef WIENERFILTER_H
#define WIENERFILTER_H

#include "blockprocessing.h"
#include <fstream>
#include <vector>
#include "Fouriertransform.h"

class WienerFilter{
private:
    std::vector<float> specreal; // real part of spectrum
    std::vector<float> specimag; // imag part of spectrum
public:
    WienerFilter();
    ~WienerFilter();
    // do Power Spectral Density estimation
    void doSpeechEnhancement(const void *, const void *, const void*, unsigned long);
    Fouriertransform FT;
};

#endif /* FOURIERTRANSFORM_H */

